{\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
The contents of this file in any form or media are not copyrighted at all.
What the hell... it wasn't that tough to write anyway.  (It could also be
better written, but what do you expect for free?)

        File : EIA2ASC.PAS
        Type : Mainline
    Language : Turbo Pascal 4.0
    Revision : 1.0
      Author : RC Henningsgard
        Date : 092890
 Description : EIA to ASCII file Converter.  Mighty simple, kinda' slow.
               Ought to be re-coded with blockread/blockwrite, but I was
               a little tired tonight.

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\}
const
  ProgramName = 'EIA2ASC - EIA to ASCII Translator';
  ProgramRevision = '1.0';
  Copyright = '(Not Copyrighted) Freeware by Rob Henningsgard';

type
  TableRecord = record
    FilterPart : array[0..255] of boolean;
    CodePart : array[0..255] of byte;
  end;

const
  UnblockCharacter = '*'; { used as a trigger, since EIA uses only one byte }
                          { as an "end of block", but in ASCII we need two  }
  CR : byte = $0D;
  LF : byte = $0A;
  Table : TableRecord = (
    FilterPart : (
      FALSE, TRUE, TRUE,FALSE, TRUE,FALSE,FALSE, TRUE,
       TRUE,FALSE,FALSE, TRUE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE, TRUE,FALSE, TRUE, TRUE,FALSE,
      FALSE, TRUE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
       TRUE,FALSE,FALSE, TRUE, TRUE, TRUE, TRUE, TRUE,
       TRUE, TRUE,FALSE, TRUE, TRUE, TRUE, TRUE, TRUE,
       TRUE, TRUE, TRUE,FALSE, TRUE, TRUE, TRUE, TRUE,
       TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE,
       TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE,
       TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE,
       TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE,
       TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE,
       TRUE, TRUE, TRUE,FALSE, TRUE,FALSE,FALSE, TRUE,
       TRUE,FALSE,FALSE, TRUE,FALSE,FALSE,FALSE,FALSE,
       TRUE,FALSE,FALSE, TRUE,FALSE, TRUE, TRUE,FALSE,
      FALSE, TRUE,FALSE, TRUE, TRUE, TRUE,FALSE,FALSE,
       TRUE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
      FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE);
    CodePart : (
      $00,$31,$32,$03,$34,$05,$06,$37,$38,$09,$0A,$25,$0C,$0D,$0E,$0F,
      $10,$11,$12,$33,$14,$35,$36,$17,$18,$39,$1A,$1B,$1C,$1D,$1E,$1F,
      $30,$21,$22,$54,$24,$56,$57,$27,$28,$5A,$2A,$2B,$2C,$2D,$2E,$2F,
      $30,$2F,$53,$33,$55,$35,$36,$58,$59,$39,$3A,$2C,$3C,$3D,$3E,$3F,
      $2D,$41,$42,$4C,$44,$4E,$4F,$47,$48,$52,$4A,$4B,$4C,$4D,$4E,$4F,
      $50,$4A,$4B,$53,$4D,$55,$56,$50,$51,$59,$5A,$25,$5C,$5D,$5E,$5F,
      $60,$41,$42,$63,$44,$65,$66,$47,$48,$69,$6A,$2E,$6C,$6D,$6E,$6F,
      $2B,$71,$72,$43,$74,$45,$46,$77,$78,$49,$7A,$7B,$7C,$7D,$7E,$7F,
      $2A,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F,
      $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F,
      $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF,
      $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF,
      $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF,
      $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF,
      $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF,
      $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF));

var
  InputFile,OutputFile : file of byte;
  InputFileName,OutputFileName : string;
  B : byte;
  I,J : longint;

begin
  writeln(ProgramName,' Rev ',ProgramRevision);
  writeln(Copyright);
  writeln;
  if (paramcount > 0)
    then InputFileName := paramstr(1)
  else begin
    write('Input file name > ');
    readln(InputFileName);
  end;
  if (paramcount > 1)
    then OutputFileName := paramstr(2)
  else begin
    write('Output file name > ');
    readln(OutputFileName);
  end;
  if (InputFileName = OutputFileName) then begin
    writeln('Illegal selection... The input and output files '+
            'must be different!');
    halt;
  end;
  assign(InputFile,InputFileName);
  reset(InputFile);
  assign(OutputFile,OutputFileName);
  rewrite(OutputFile);
  I := filesize(InputFile) div 10;
  J := 0;
  write('Converting <',InputFileName,'> to ASCII');
  with Table do begin
    while not eof(InputFile) do begin
      read(InputFile,B);
      inc(J);
      if (J = I) then begin { give the guy a sign we're alive }
        write('.');
        J := 0;
      end;
      if FilterPart[B] then begin
        if (CodePart[B] = ord(UnblockCharacter))
          then write(OutputFile,CR,LF)
          else write(OutputFile,CodePart[B]);
      end;
    end;
  end; { with }
  writeln(' done making <',OutputFileName,'>');
  close(InputFile);
  close(OutputFile);
end.
